Unit AFJ0C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAF12_p;

procedure AFJ0C(var BR :Array of Real; var BI :Array of Real;
                var CR :Array of Real; var CI :Array of Real;
                N :Integer; var IERR :Integer);

implementation

procedure AFJ0C(var BR :Array of Real; var BI :Array of Real;
                var CR :Array of Real; var CI :Array of Real;
                N :Integer; var IERR :Integer);
var
I :Integer;
W,UR,UI,BRI,BII,CRI,CII,B,SB,C,SC,S :Real;
CB,CC :Complex;
const
SYS056 :Real = 1.175495E-38;
SYS052 :Real = 1.1920928E-7;
label
_1,_2,_3,_4,_5,_6,_7;
begin
{      SYS056 = SYS055 }
W := 8.0*SYS052;
IERR := 0;
CR[0] := 1.0;
CI[0] := 0.0;
UR := 1.0;
UI := 0.0;
if ( N = 1 ) 
 then goto _7;
for I:=2 to N do
 begin
  BRI := BR[I-1];
  BII := BI[I-1];
  CRI := CR[I-1];
  CII := CI[I-1];
  CB := Cmplx(BRI,BII);
  B := Cabs(CB);
  SB := Sqrt(B);
  CC := Cmplx(CRI,CII);
  C := Cabs(CC);
  SC := Sqrt(C);
  S := SB*SC;
  BR[I-1] := S;
  if ( B = 0.0 ) and ( C = 0.0 ) 
   then goto _2;
  if ( S = 0.0 ) 
   then goto _6;
  SB := BRI/B;
  SC := CRI/C;
  if ( Abs(SB-SC) > ( Abs(SB)+ Abs(SC))*W ) 
   then goto _5;
  SB := 0.0;
  SC := 0.0;
  if ( BII <> 0.0 ) 
   then SB := Sign(1.0,BII);
  if ( CII <> 0.0 ) 
   then SC := -Sign(1.0,CII);
  if ( SB <> SC ) 
   then goto _5;
  if ( IERR = 68 ) 
   then goto _4;
  S := 1.0/S;
  CRI := CRI*S;
  CII := CII*S;
  C := EMax1( Abs(CRI), Abs(CII));
  B := EMax1( Abs(UR), Abs(UI));
  if ( C*SYS056*B < 0.5 ) 
   then goto _1;
  IERR := 68;
  goto _4;
_1:
  BRI := UR*CRI-UI*CII;
  BII := UI*CRI+UR*CII;
  goto _3;
_2:
  BRI := 1.0;
  BII := 0.0;
_3:
  CR[I-1] := BRI;
  CI[I-1] := BII;
  UR := BRI;
  UI := BII;
  if ( UR = 0.0 ) and ( UI = 0.0 ) 
   then IERR := 68;
_4:
 end;
goto _7;
_5:
IERR := 66;
goto _7;
_6:
IERR := 67;
_7:
if ( IERR <> 0 ) 
 then UTAF12(IERR,4);
end;

end.
